Priority: Severe/Regression

Assignee:
Affected QGIS version:2.4.0 Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 19231

Description

Hi.

I have a problem in QGIS 2.4 and Python Init functions working with UI form. In previus versions of QGIS everything is working fine but in

2.4 every time I add one object, QGIS adds second one in the same place. It happens if I work on SHP files or on PostgreSQL database.

Second object has the same attributes as the first one (instead of GID in PostgreSQL).

I don't know if something has change in QGIS 2.4 and Python Init function. I've attached some project (works in Windows) with 2 layers

(point and line), form.ui and Python script (does nothing, apart of making problem) which is part of my biger project.

Please let me know if I should change something in Python code or there is a problem in QGIS 2.4?

Thanks!

Associated revisions

Revision 9f073834 - 2014-07-23 12:11 AM - Matthias Kuhn

Only add feature once when python init function is set on attribute form

Fix #10862

Revision bd5846b5 - 2014-07-23 09:39 AM - Matthias Kuhn

Only add feature once when python init function is set on attribute form

Fix #10862

History

#1 - 2014-07-10 05:19 AM - Jürgen Fischer

- Subject changed from QGIS 2.4 adds 2 objects in one click while using Phyton Init functions and own UI form.. to QGIS 2.4 adds 2 objects in one click 

while using Python Init functions and own UI form..

#2 - 2014-07-20 01:54 AM - Thomas Kreuzer

I have the exact same problem for PostGIS layers, on Windows and on Linux.

And the problem is only because of the "Python Init Function", whether you use a custom ui or not doesn't matter.

And it doesn't matter how the "Python Init Function" looks like, even if it is just

def openForm(dialog, layer, feature):

   pass

QGIS will create two exact features.
This renders most database interfaces useless.

#3 - 2014-07-21 04:02 AM - Seb Radzimski

OK now I know it is not only my problem. Is there any chance to fix it in 2.4 or maybe 2.6 QGIS? For now I can try to delete this duplicate object on

database level...

Regards!

#4 - 2014-07-21 08:15 AM - Giovanni Manghi

- Status changed from Open to Feedback

Seb Radzimski wrote:

OK now I know it is not only my problem. Is there any chance to fix it in 2.4 or maybe 2.6 QGIS? For now I can try to delete this duplicate object on

database level...

Regards!

did it worked as expected in previous qgis releases?

#5 - 2014-07-21 10:02 AM - Thomas Kreuzer

It worked in the 2.3.0-24 weekly build, at least.

I maybe should say that I am on x64.

#6 - 2014-07-21 10:54 AM - Giovanni Manghi

- Status changed from Feedback to Open

- Priority changed from Normal to Severe/Regression

#7 - 2014-07-21 10:17 PM - Seb Radzimski

It happens in QGIS 2.4 installed on Windows 32 and 64 bit (OSGeo4W on 7x64 and standalone installer on server 2008x86 nad XP) while working with

postgis database or shp files. In previus version of QGIS (2.0 and 2.2) the same project works fine (no duplicates are added). You can check it with files

attached in first post.

#8 - 2014-07-22 12:24 AM - Andreas Neumann

hm - this should definitely go into a 2.4 bugfix release.

I very much hope that there will be a 2.4 bugfix release.

#9 - 2014-07-22 03:12 PM - Matthias Kuhn

- Status changed from Open to Closed

Fixed in changeset commit:"9f073834a1e005727ee9cb74628203228586803b".
Files

error.zip 7.8 KB 2014-07-10 Seb Radzimski
